//		=============================================================
//						Created by .inStant
//						Website:	ins-clan.net
//						Email:		instant@ins-clan.net
//								-------------
//					http://steamcommunity.com/id/deadmantroll
//		=============================================================
//									ENJOY!
//		=============================================================

#include <sourcemod>
#include <morecolors>
#include <cstrike>

static String:TLogPath[PLATFORM_MAX_PATH];
//--------------------------------
new TEAM_1 = 3;
new TEAM_2 = 2;
//--------------------------------
#define MAX_STEAMID 25
#define PLN_VRSN "2.1"
new Handle:g_Enabled;
//--------------------------------
new bool:Trusted[MAXPLAYERS + 1];
new Handle:db = INVALID_HANDLE;
new Handle:KickMsg = INVALID_HANDLE;
//--------------------------------

public GetOtherTeam(team)
{
	if(team == TEAM_2)
		return TEAM_1;
	else
		return TEAM_2;
}

public OnPluginStart() 
{
	BuildPath(Path_SM, TLogPath, sizeof(TLogPath), "logs/Trusted.txt");
	
	LogDB();
	
	RegConsoleCmd("sm_t", MessageTrust);
	RegConsoleCmd("sm_tmenu", OpenTMenu);
	RegAdminCmd("sm_givetrust", GiveTClient, ADMFLAG_UNBAN);
	RegAdminCmd("sm_removetrust", RemoveTClient, ADMFLAG_UNBAN);
	
	AddCommandListener(CallBack, "say");
	
	g_Enabled = CreateConVar("sm_trusted_enable", "1", "Sets whether Trusted is enabled!");
	CreateConVar("sm_trusted_version", PLN_VRSN, "Trusted menu that is meant to keep the server moving when there are no admins available", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	KickMsg = CreateConVar("sm_trusted_kmsg", "You have been kicked by a trusted.", "Kick message sent to kicked client", FCVAR_PLUGIN);
}

public OnClientDisconnect(client)
{
	Trusted[client] = false;
}

LogDB()
{
	SQL_TConnect(GoToDB, "inSTrust");
}

public GoToDB(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (hndl == INVALID_HANDLE)
	{	
		new String:currentMap[25], String:srvCmd[50];
		GetCurrentMap(currentMap, sizeof(currentMap));
		Format(srvCmd, sizeof(srvCmd), "changelevel %s", currentMap);
		LogError("Database failure: %s", error);
	}
	else
	{
		PrintToServer("Connection to Trusted MENU has been found!");
		db = hndl;
	}
}

public OnClientPutInServer(client)
{
	CheckTrust(client);
}

public Action:OpenTMenu(client, args)
{
	new Tenable = GetConVarInt(g_Enabled);
	
	if (!Tenable)
	{
		return;
	}
	
	datMenu(client);
}

public Action:datMenu(client)
{
	if (Trusted[client])
	{
		new Handle:panel = CreatePanel();
		SetPanelTitle(panel, "[inS] Trusted Menu");
		DrawPanelText(panel, "     -By inStant");
		DrawPanelText(panel, "  ");
		DrawPanelItem(panel, "Kick Players");
		DrawPanelItem(panel, "Slay Players");
		DrawPanelItem(panel, "Respawn Players");
		DrawPanelItem(panel, "Swap Players");
		SendPanelToClient(panel, client, MenuTaction, 5);
	}
	else
	{
		CPrintToChat(client, "{olive}[inS] {teal}%N, You do not have permission!.", client);
	}
}

public MenuTaction(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		switch (param2)
		{
			case 1:
			{
				KickPlayer(param1);
			}
			case 2:
			{
				SlayPlayer(param1);
            }
			case 3:
			{
				RespawnPlayer(param1);
			}
			case 4:
			{
				SwapPlayer(param1);
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		PrintToServer("client %d's menu was cancelled.  Reason: %d", param1, param2);
	}
}

public Action:RespawnPlayer(client)
{
	new Handle:menu = CreateMenu(RespawnHandle);
	SetMenuTitle(menu, "Select Player to Respawn");
	
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		new String:name[64];
		
		if (IsClientInGame(i))
		{
			GetClientName(i, name, sizeof(name));
			AddMenuItem(menu, name, name);
		}
	}
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, 0);
}

public ReopenMenu(client)
{
	new Handle:panel = CreatePanel();
	SetPanelTitle(panel, "[inS] Trusted Menu");
	DrawPanelText(panel, "     -By inStant");
	DrawPanelText(panel, "  ");
	DrawPanelItem(panel, "Kick Players");
	DrawPanelItem(panel, "Slay Players");
	DrawPanelItem(panel, "Respawn Players");
	DrawPanelItem(panel, "Swap Players");
	SendPanelToClient(panel, client, MenuTaction, 10);
}

public Action:SwapPlayer(client)
{
	new Handle:menu = CreateMenu(SwapHandle);
	SetMenuTitle(menu, "Select Player to Swap");
	
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		new String:name[64];
		
		if (IsClientInGame(i))
		{
			GetClientName(i, name, sizeof(name));
			AddMenuItem(menu, name, name);
		}
	}
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, 0);
}

public Action:SlayPlayer(client)
{
	new Handle:menu = CreateMenu(SlayHandle);
	SetMenuTitle(menu, "Select Player to Slay");
	
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		new String:name[64];
		
		if ((IsClientInGame(i)) && IsPlayerAlive(i))
		{
			GetClientName(i, name, sizeof(name));
			AddMenuItem(menu, name, name);
		}
	}
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, 0);
}

public Action:KickPlayer(client)
{
	new Handle:menu = CreateMenu(kickHandle);
	SetMenuTitle(menu, "Select Player to Kick");
	
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		new String:name[64];
		
		if (IsClientInGame(i))
		{
			GetClientName(i, name, sizeof(name));
			AddMenuItem(menu, name, name);
		}
	}
	SetMenuExitBackButton(menu, true);
	DisplayMenu(menu, client, 0);
}

public SlayHandle(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select) 
	{
		new String:nameclient2[64];
		new String:loopname[64];
		GetMenuItem(menu, param2, nameclient2, sizeof(nameclient2));
		for (new i = 1; i <= GetMaxClients(); i++)
		{
			if ((IsClientInGame(i)) && (IsPlayerAlive(i)))
			{
				new String:cname[64],String:TrustID[32],String:TargetID[32];
				
				GetClientAuthString(client, TrustID, sizeof(TrustID));
				GetClientAuthString(i, TargetID, sizeof(TargetID));
				GetClientName(client, cname, sizeof(cname));
				GetClientName(i, loopname, sizeof(loopname));
				if ((StrEqual(loopname, nameclient2, true)) && (IsClientInGame(i)))
				{
					FakeClientCommand(i, "kill");
					datMenu(client);
					
					CPrintToChatAll("{olive}[inS] {teal}%s was slayed by {green}[{olive}Trusted{green}]{teal} %s", loopname, cname);
					
					new Handle:fileHandle = OpenFile(TLogPath,"a");
					if (fileHandle != INVALID_HANDLE)
					{
						WriteFileLine(fileHandle, "%s <%s>: slayed %s <%s>", cname, TrustID, loopname, TargetID);
						CloseHandle(fileHandle);
					}
				}
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		ReopenMenu(client);
	}
}

public RespawnHandle(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select) 
	{
		new String:nameclient2[64];
		new String:loopname[64];
		GetMenuItem(menu, param2, nameclient2, sizeof(nameclient2));
		for (new i = 1; i <= GetMaxClients(); i++)
		{
			if (IsClientInGame(i))
			{
				new String:TrustID[32],String:TargetID[32],String:cname[64];
				
				GetClientAuthString(client, TrustID, sizeof(TrustID));
				GetClientAuthString(i, TargetID, sizeof(TargetID));
				GetClientName(client, cname, sizeof(cname));
				GetClientName(i, loopname, sizeof(loopname));
				if ((StrEqual(loopname, nameclient2, true)) && (IsClientInGame(i)))
				{
					if (IsPlayerAlive(i))
					{
						CPrintToChat(client, "{olive}[inS] {teal}The person must be dead!");
					}
					else
					{
						CS_RespawnPlayer(i);
						datMenu(client);
						
						CPrintToChatAll("{olive}[inS] {teal}%s was re-spawned by {green}[{olive}Trusted{green}]{teal} %s", loopname, cname);
						
						new Handle:fileHandle = OpenFile(TLogPath,"a");
						if (fileHandle != INVALID_HANDLE)
						{
							WriteFileLine(fileHandle, "%s <%s>: respawned %s <%s>", cname, TrustID, loopname, TargetID);
							CloseHandle(fileHandle);
						}
					}
				}
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		ReopenMenu(client);
	}
}

public SwapHandle(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select) 
	{
		new String:nameclient2[64];
		new String:loopname[64];
		GetMenuItem(menu, param2, nameclient2, sizeof(nameclient2));
		for (new i = 1; i <= GetMaxClients(); i++)
		{
			if (IsClientInGame(i))
			{
				new String:TrustID[32],String:TargetID[32],String:cname[64];
				
				GetClientAuthString(client, TrustID, sizeof(TrustID));
				GetClientAuthString(i, TargetID, sizeof(TargetID));
				GetClientName(client, cname, sizeof(cname));
				GetClientName(i, loopname, sizeof(loopname));
				if ((StrEqual(loopname, nameclient2, true)) && (IsClientInGame(i)))
				{
					ChangeClientTeam(i, GetOtherTeam(GetClientTeam(i)));
					datMenu(client);
					
					CPrintToChatAll("{olive}[inS] {teal}%s was swapped by {green}[{olive}Trusted{green}]{teal} %s", loopname, cname);
					
					new Handle:fileHandle = OpenFile(TLogPath,"a");
					if (fileHandle != INVALID_HANDLE)
					{
						WriteFileLine(fileHandle, "%s <%s>: swapped %s <%s>", cname, TrustID, loopname, TargetID);
						CloseHandle(fileHandle);
					}
				}
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		ReopenMenu(client);
	}
}

public kickHandle(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select) 
	{
		new String:nameclient2[64];
		new String:loopname[64];
		GetMenuItem(menu, param2, nameclient2, sizeof(nameclient2));
		for (new i = 1; i <= GetMaxClients(); i++)
		{
			if (IsClientInGame(i))
			{
				new String:Message[512],String:TrustID[32],String:TargetID[32],String:cname[64];
				
				GetClientAuthString(client, TrustID, sizeof(TrustID));
				GetClientAuthString(i, TargetID, sizeof(TargetID));
				GetClientName(client, cname, sizeof(cname));
				GetClientName(i, loopname, sizeof(loopname));
				if ((StrEqual(loopname, nameclient2, true)) && (IsClientInGame(i)))
				{
					GetConVarString(KickMsg, Message, sizeof(Message));
					KickClient(i, Message);
					datMenu(client);

					CPrintToChatAll("{olive}[inS] {teal}%s was kicked by {green}[{olive}Trusted{green}]{teal} %s", loopname, cname);
					
					new Handle:fileHandle = OpenFile(TLogPath,"a");
					if (fileHandle != INVALID_HANDLE)
					{
						WriteFileLine(fileHandle, "%s <%s>: kicked %s <%s>", cname, TrustID, loopname, TargetID);
						CloseHandle(fileHandle);
					}
				}
			}
		}
	}
	else if (action == MenuAction_Cancel)
	{
		ReopenMenu(client);
	}
}

public Action:GiveTClient(client, args)
{
	if (args < 1)
	{
		ReplyToCommand(client, "[inS] Usage: sm_givetrust <player>");
		return Plugin_Handled;
	}
		
	decl String:arg[32];
	GetCmdArg(1, arg, sizeof(arg));
	
	new target = FindTarget(client, arg);
	
	if( target > 0 && target <= MaxClients )
	{
		if (Trusted[target])
		{
			CPrintToChatAll("{olive}[inS] {teal}%N is already a Trusted Member!", target);
		}
		else
		{
			if (IsClientInGame(target))
			{
				new String:query[255], String:tName[40], String:Tsteam[25], String:Psteam[25];
				
				GetClientName(target, tName, sizeof(tName));
				GetClientAuthString(target, Tsteam, sizeof(Tsteam));
				GetClientAuthString(client, Psteam, sizeof(Psteam));
				
				Format(query, sizeof(query), "INSERT INTO Trusted(client, clientid, approvedid) VALUES('%s', '%s', '%s')",tName , Tsteam, Psteam); 
				CPrintToChat(client, "{olive}[inS] {teal}Trusted is now Added!!", client);
				Trusted[target] = true;
				
				SQL_TQuery(db, T_addTrust, query, client);
				//SQL_FastQuery(db, query);
			}
		}
	}
	return Plugin_Handled;
}

public Action:RemoveTClient(client, args)
{
	if (args < 1)
	{
		ReplyToCommand(client, "[inS] Usage: sm_removetrust <player>");
		return Plugin_Handled;
	}
		
	decl String:arg[32];
	GetCmdArg(1, arg, sizeof(arg));
	
	new target = FindTarget(client, arg);
	
	if( target > 0 && target <= MaxClients )
	{
		if (Trusted[target])
		{
			if (IsClientInGame(target))
			{
				new String:query[255], String:tName[40], String:Tsteam[25], String:Psteam[25];
				
				GetClientName(target, tName, sizeof(tName));
				GetClientAuthString(target, Tsteam, sizeof(Tsteam));
				GetClientAuthString(client, Psteam, sizeof(Psteam));
				
				Format(query, sizeof(query), "DELETE FROM Trusted WHERE clientid = '%s'",Tsteam); 
				CPrintToChat(client, "{olive}[inS] {teal}Player's Trusted is now revoked!!", client);
				Trusted[target] = false;
				
				SQL_TQuery(db, T_addTrust, query, client);
			}
		}
		else
		{
			CPrintToChat(client, "{olive}[inS] {teal}That Player isn't a Trusted!!");
		}
	}
	return Plugin_Handled;
}

public Action:CallBack(client, const String:command[], args)
{
	new Tenable = GetConVarInt(g_Enabled);
	
	if (!Tenable)
	{
		return;
	}
	
	if (Trusted[client])
	{
		decl String:msg[256];
		GetCmdArg(1, msg, sizeof(msg))
		
		if (!strcmp(msg,"/tkick",false) || !strcmp(msg,"!tkick",false))
		{
			KickPlayer(client);
		}
		if (!strcmp(msg,"/tslay",false) || !strcmp(msg,"!tslay",false))
		{
			SlayPlayer(client);
		}
		if (!strcmp(msg,"/tspawn",false) || !strcmp(msg,"!tspawn",false))
		{
			RespawnPlayer(client);
		}
		
		if (!strcmp(msg,"/tswap",false) || !strcmp(msg,"!tswap",false))
		{
			SwapPlayer(client);
		}
	}
}

public Action:MessageTrust(client, args)
{
	decl String:msg[256];
	GetCmdArg(1, msg, sizeof(msg));
	
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		if(Trusted[i])
		{
			if (IsClientInGame(i))
			{
				CPrintToChat(i, "{olive}[Trusted-Chat] {white}%N {teal}%s ",client , msg);
			}
		}
	}
}

public T_addTrust(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if (hndl == INVALID_HANDLE)
	{
		PrintToServer("Failed to query (error: %s)", error);
	} 
}

CheckTrust(client)
{
	new String:auth[25];
	GetClientAuthString(client, auth, sizeof(auth));
	decl String:query[255];
	Format(query, sizeof(query), "SELECT clientid FROM Trusted WHERE clientid = '%s'", auth);

	SQL_TQuery(db, T_CheckTrusted, query, client);
}

public T_CheckTrusted(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if (hndl == INVALID_HANDLE)
	{
		LogError("Query failed! %s", error);
	}
	else if (SQL_GetRowCount(hndl)) 
	{
		Trusted[client] = true;
	}
}